using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.DebitNote.Cqrs;

public record DeleteDebitNoteByIdCommand(string Id) : IRequest<bool>;

public class DeleteDebitNoteByIdHandler : IRequestHandler<DeleteDebitNoteByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteDebitNoteByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteDebitNoteByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.DebitNote
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.DebitNote.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}